<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org" xmlns:hx="http://www.w3.org/1999/xhtml">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Landon Hotel | Guests</title>
	<link rel="stylesheet" type="text/css" th:href="@{/css/style.css}"/>
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
		  crossorigin="anonymous">
</head>
<body>
<div th:replace="~{fragments/header :: header('guests')}"></div>
<main class="container">
	<h1>Guests</h1>
	<div class="guest-header">

		<button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#newGuestModal">
			New Guest
		</button>
		<input class="form-control" type="search"
			   name="search" placeholder="Begin Typing To Search Users..."
			   hx:post="@{/guests/search}"
			   hx-trigger="input changed delay:500ms, search"
			   hx-target="#guestsTbody"
			   hx-indicator=".htmx-indicator">
		<span class="htmx-indicator">
			Loading...
		</span>
	</div>
	<!--	NEW USER MODAL-->
	<div class="modal fade" id="newGuestModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
		<div class="modal-dialog modal-dialog-centered">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title" id="exampleModalLabel">New Guest</h5>
					<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
				</div>
				<div class="modal-body">
					<form hx:post="@{/guests}" th:object="${guest}" method="post" hx-target="#guestsTbody"
						  hx-swap="afterbegin settle:1s">
						<div class="modal-body">
							<div class="form-group">
								<label for="firstName">First Name</label>
								<input type="text" class="form-control" id="firstName" th:field="*{firstName}">
							</div>
							<div class="form-group">
								<label for="lastName">Last Name</label>
								<input type="text" class="form-control" id="lastName" th:field="*{lastName}">
							</div>
							<div class="form-group">
								<label for="phoneNumber">Phone Number</label>
								<input type="text" class="form-control" id="phoneNumber" th:field="*{phoneNumber}">
							</div>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
							<button type="submit" class="btn btn-primary">Save changes</button>
						</div>
					</form>
				</div>
			</div>
		</div>
	</div>
	<table class="table">
		<thead>
		<tr>
			<th>Name</th>
			<th>Last Name</th>
			<th>Phone</th>
			<th>Edit</th>
			<th>Delete</th>
		</tr>
		<tbody id="guestsTbody" hx-target="closest tr" hx-swap="outerHTML">
		<tr th:insert="fragments/guests :: guest-entry(${guest})" th:each="guest : ${guests}">
		</tr>
		</tbody>
	</table>
</main>
<script type="text/javascript" th:src="@{/webjars/htmx.org/dist/htmx.min.js}"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"
		integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p"
		crossorigin="anonymous"></script>
<script>
	document.body.addEventListener('htmx:afterRequest', function (event) {
		// Check if the swap target is your response container and if the response is successful
		if (event.detail.target.id === 'guestsTbody' && event.detail.xhr.status === 200) {
			var myModalEl = document.getElementById('newGuestModal');
			var modal = bootstrap.Modal.getInstance(myModalEl);
			modal.hide();
		}
	});
</script>
</body>
</html>
